/*
	search routine generated by gen.
	skip=sfC, match=fwd (using fwdl), shift=inc
*/
/*
 * The authors of this software are Andrew Hume and Daniel Sunday.
 * 
 * Copyright (c) 1991 by AT&T and Daniel Sunday.
 * 
 * Permission to use, copy, modify, and distribute this software for any
 * purpose without fee is hereby granted, provided that this entire notice
 * is included in all copies of any software which is or includes a copy
 * or modification of this software and in all copies of the supporting
 * documentation for such software.
 * 
 * THIS SOFTWARE IS BEING PROVIDED "AS IS", WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTY.  IN PARTICULAR, NEITHER THE AUTHORS NOR AT&T MAKE ANY
 * REPRESENTATION OR WARRANTY OF ANY KIND CONCERNING THE MERCHANTABILITY
 * OF THIS SOFTWARE OR ITS FITNESS FOR ANY PARTICULAR PURPOSE.
 */

#ifndef	CHARTYPE
#define	CHARTYPE	unsigned char
#endif
#define	MAXPAT	256

#include	"stats.h"

#ifndef	TABTYPE
#define	TABTYPE	long
#endif
typedef TABTYPE Tab;

static struct
{
	int patlen;
	CHARTYPE pat[MAXPAT];
} pat;

prep(base, m)
	CHARTYPE *base;
	register m;
{
	CHARTYPE *skipc;

	pat.patlen = m;
	if(m > MAXPAT)
		abort();
	memcpy(pat.pat, base, m);
	skipc = 0;
	stats.len = m;
	skipc = &pat.pat[0];
}

exec(base, n)
	CHARTYPE *base;
{
	int nmatch = 0;
	register CHARTYPE *e, *s;
	register CHARTYPE ch;
	register np1;
	extern char *memchr();
	register CHARTYPE *p, *q;
	register CHARTYPE *ep;

	s = base;
	e = base + n - pat.patlen;
	np1 = n+1;
	ch = pat.pat[0];
	base[n] = ch;
	ep = pat.pat + pat.patlen;
	while(s < e){
#ifdef	STATS
		while(ch != *s++)
			stats.jump++;
		stats.jump++;
		if(--s > e)
			break;
#else
		s = (CHARTYPE *)memchr(s, ch, np1);	/* must find it */
		if(s > e)
			break;
#endif
#ifdef	STATS
		stats.slow++;
#endif
		for(p = pat.pat+1, q = s+1; p < ep; ){
#ifdef	STATS
			stats.cmp++;
#endif
			if(*q++ != *p++)
				goto mismatch;
		}
		nmatch++;
	mismatch:
		s++;
#ifdef	STATS
		stats.step[1]++;
#endif
	}
	return(nmatch);
}
