/*
	search routine generated by gen.
	skip=uf, match=fwdm (using fwdmr), guard=guardr (using guard), shift=inc
*/
#include	"freq.h"
/*
 * The authors of this software are Andrew Hume and Daniel Sunday.
 * 
 * Copyright (c) 1991 by AT&T and Daniel Sunday.
 * 
 * Permission to use, copy, modify, and distribute this software for any
 * purpose without fee is hereby granted, provided that this entire notice
 * is included in all copies of any software which is or includes a copy
 * or modification of this software and in all copies of the supporting
 * documentation for such software.
 * 
 * THIS SOFTWARE IS BEING PROVIDED "AS IS", WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTY.  IN PARTICULAR, NEITHER THE AUTHORS NOR AT&T MAKE ANY
 * REPRESENTATION OR WARRANTY OF ANY KIND CONCERNING THE MERCHANTABILITY
 * OF THIS SOFTWARE OR ITS FITNESS FOR ANY PARTICULAR PURPOSE.
 */

#ifndef	CHARTYPE
#define	CHARTYPE	unsigned char
#endif
#define	MAXPAT	256

#include	"stats.h"

#ifndef	TABTYPE
#define	TABTYPE	long
#endif
typedef TABTYPE Tab;

static struct
{
	int patlen;
	CHARTYPE pat[MAXPAT];
	Tab delta[256];
	int rarec, rareoff;
} pat;

prep(base, m)
	CHARTYPE *base;
	register m;
{
	CHARTYPE *skipc;
	register CHARTYPE *pe, *p;
	register int j;
	register Tab *d;
	int rrr, rr;

	pat.patlen = m;
	if(m > MAXPAT)
		abort();
	memcpy(pat.pat, base, m);
	skipc = 0;
	stats.len = m;
	d = pat.delta;
	for(j = 0; j < 256; j++)
		d[j] = pat.patlen;
	for(p = pat.pat, pe = p+m-1; p < pe; p++)
		d[*p] = pe-p;
	d[*p] = 0;
	skipc = (CHARTYPE *)p;
	rrr = 0;
	for(rr = 1; rr < m; rr++){
		if(freq[pat.pat[rr]] < freq[pat.pat[rrr]])
			rrr = rr;
	}
	pat.rarec = pat.pat[rrr];
	pat.rareoff = rrr - (m-1);
}

exec(base, n)
	CHARTYPE *base;
{
	int nmatch = 0;
	register CHARTYPE *e, *s;
	register Tab *d0 = pat.delta;
	register k;
	register ro, rc;
#ifdef	STATS
	register CHARTYPE *p, *q;
	register CHARTYPE *ep;
#else
	register CHARTYPE *sp;
#endif
	register n1;

	s = base+pat.patlen-1;
	e = base+n;
	memset(e, pat.pat[pat.patlen-1], pat.patlen);
	ro = pat.rareoff;
	rc = pat.rarec;
	n1 = pat.patlen-1;
#ifdef	STATS
	ep = pat.pat + n1;
#else
	sp = pat.pat;
#endif
	while(s < e){
#ifdef	STATS
		k = d0[*s];
		stats.jump++;
		while(k){
			stats.jump++; stats.step[k]++;
			k = d0[*(s += k)];
			stats.jump++; stats.step[k]++;
			k = d0[*(s += k)];
			stats.jump++; stats.step[k]++;
			k = d0[*(s += k)];
		}
#else
		k = d0[*s];
		while(k){
			k = d0[*(s += k)];
			k = d0[*(s += k)];
			k = d0[*(s += k)];
		}
#endif
		if(s >= e)
			break;
#ifdef	STATS
		stats.slow++;
#endif
		if(s[ro] != rc)
			goto mismatch;
#ifdef	STATS
		for(p = pat.pat, q = s-n1; p < ep; ){
			stats.cmp++;
			if(*q++ != *p++)
				goto mismatch;
		}
#else
		if(memcmp(sp, s-n1, n1))	/* warning: some memcmps don't care for n1==0 */
			goto mismatch;
#endif
		nmatch++;
	mismatch:
		s++;
#ifdef	STATS
		stats.step[1]++;
#endif
	}
	return(nmatch);
}
