/*
	search routine generated by gen.
	skip=uf, match=om (using omr), shift=md2
*/
#include	"freq.h"
/*
 * The authors of this software are Andrew Hume and Daniel Sunday.
 * 
 * Copyright (c) 1991 by AT&T and Daniel Sunday.
 * 
 * Permission to use, copy, modify, and distribute this software for any
 * purpose without fee is hereby granted, provided that this entire notice
 * is included in all copies of any software which is or includes a copy
 * or modification of this software and in all copies of the supporting
 * documentation for such software.
 * 
 * THIS SOFTWARE IS BEING PROVIDED "AS IS", WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTY.  IN PARTICULAR, NEITHER THE AUTHORS NOR AT&T MAKE ANY
 * REPRESENTATION OR WARRANTY OF ANY KIND CONCERNING THE MERCHANTABILITY
 * OF THIS SOFTWARE OR ITS FITNESS FOR ANY PARTICULAR PURPOSE.
 */

#ifndef	CHARTYPE
#define	CHARTYPE	unsigned char
#endif
#define	MAXPAT	256

static struct om
{
	int loc;
	CHARTYPE c;
};

om_pcmp(p1, p2)
	register struct om *p1, *p2;
{
	register float f = freq[p1->c] - freq[p2->c];

	if(f < 0)
		return(-1);
	else if(f > 0)
		return(1);
	return(p2->loc - p1->loc);
}
#include	"stats.h"

#ifndef	TABTYPE
#define	TABTYPE	long
#endif
typedef TABTYPE Tab;

static struct
{
	int patlen;
	CHARTYPE pat[MAXPAT];
	Tab delta[256];
	struct om om[1024];
	int nom;
	int md2;
} pat;

prep(base, m)
	CHARTYPE *base;
	register m;
{
	CHARTYPE *skipc;
	register CHARTYPE *pe, *p;
	register int j;
	register Tab *d;
	register struct om *op;
	register CHARTYPE *opb, *ope;
	register CHARTYPE *pmd2;

	pat.patlen = m;
	if(m > MAXPAT)
		abort();
	memcpy(pat.pat, base, m);
	skipc = 0;
	stats.len = m;
	d = pat.delta;
	for(j = 0; j < 256; j++)
		d[j] = pat.patlen;
	for(p = pat.pat, pe = p+m-1; p < pe; p++)
		d[*p] = pe-p;
	d[*p] = 0;
	skipc = (CHARTYPE *)p;
	for(op = pat.om, opb = pat.pat, ope = opb+m-1; opb < ope; opb++){
		op->loc = opb - ope;
		op->c = *opb;
		op++;
	}
	qsort(pat.om, pat.nom = op-pat.om, sizeof(pat.om[0]), om_pcmp);
	for(pmd2 = skipc-1; pmd2 >= pat.pat; pmd2--)
		if (*pmd2 == *skipc) break;
	pat.md2 = skipc - pmd2;	/* *pmd2 is first leftward reoccurance of *pe */
#ifdef	STATS
	stats.extra += pat.md2;
#endif
}

exec(base, n)
	CHARTYPE *base;
{
	int nmatch = 0;
	register CHARTYPE *e, *s;
	register Tab *d0 = pat.delta;
	register k;
	register struct om *op, *oep;
	register md2 = pat.md2;

	s = base+pat.patlen-1;
	e = base+n;
	memset(e, pat.pat[pat.patlen-1], pat.patlen);
	oep = pat.om+pat.nom;
	while(s < e){
#ifdef	STATS
		k = d0[*s];
		stats.jump++;
		while(k){
			stats.jump++; stats.step[k]++;
			k = d0[*(s += k)];
			stats.jump++; stats.step[k]++;
			k = d0[*(s += k)];
			stats.jump++; stats.step[k]++;
			k = d0[*(s += k)];
		}
#else
		k = d0[*s];
		while(k){
			k = d0[*(s += k)];
			k = d0[*(s += k)];
			k = d0[*(s += k)];
		}
#endif
		if(s >= e)
			break;
#ifdef	STATS
		stats.slow++;
#endif
		for(op = pat.om; op < oep; ++op){
#ifdef	STATS
			stats.cmp++;
#endif
			if(op->c != s[op->loc])
				goto mismatch;
		}
		nmatch++;
	mismatch:
#ifdef	STATS
		stats.step[md2]++; stats.jump++;
#endif
		s += md2;
	}
	return(nmatch);
}
